package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.kittyProperties;
import com.example.fuzzControll.constents.protocolConstent;
import com.example.fuzzControll.constents.vulnerabilityTypeConstent;
import com.example.fuzzControll.pojo.vo.protocolGenerationEntity;
import com.example.fuzzControll.pojo.vo.vulnerabilityTypeEntity;
import com.example.fuzzControll.service.vulnerabilityTypeService;
import com.example.fuzzControll.tools.cmdTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Slf4j
@Service("vulnerabilityTypeService")
public class vulnerabilityTypeServiceImpl implements vulnerabilityTypeService {
    cmdTools cmdTools = new cmdTools();
    @Autowired
    kittyProperties kitty;

    @Override
    public void generation(vulnerabilityTypeEntity vulnerabilityTypeEntity) {
        String cmd = parseParameters(vulnerabilityTypeEntity);
        cmdTools.runProgramCmdAndResultTofile(cmd);
    }

    public String parseParameters(vulnerabilityTypeEntity vulnerabilityTypeEntity) {
        switch (vulnerabilityTypeEntity.getVulnerabilityTypeName().toLowerCase()) {
            case "array_index_out_of_bounds_vulnerabilit":
                return arrayIndexOutOfBoundsVulnerabilitCmd(vulnerabilityTypeEntity);
            default:
                log.error("未知漏洞！[{}]", vulnerabilityTypeEntity.getVulnerabilityTypeName());
                return null;
        }
    }

    private String arrayIndexOutOfBoundsVulnerabilitCmd(vulnerabilityTypeEntity vulnerabilityTypeEntity) {
        return kitty.getVenvPath() + " " + kitty.getVulnerabilityTypePath() +"vul_types_test.py "+ vulnerabilityTypeConstent.ARRAY_INDEX_OUT_OF_BOUNDS_VULNERABILIT ;
    }
    //todo 还有很多类型要写
}
